//pl0符号表管理的验证程序
// 要点：
//     1 本例有2个函数：函数enter用于向符号表添加新的符号，并确定标识符的有关属性。函数position用于查找符号表，并返回相关表索引。
// 关键字：变量不变式、宏定义、带命名行为的函数协议
#include <stdio.h>
#include "specification.h"

//@ ghost _Bool too_many_variables;
//@ ghost _Bool symbol_table_too_short;

void enter(const enum object k){// enter object into table
    if(tx >= txmax){
    printf("%s\n", "symbol table too short");
    //@ ghost symbol_table_too_short = true;
    exit(1);
    }
    tx=tx+1;
    strcpy(table[tx].name,id);                // 这个函数调用会引起对table[tx].name的修改，下标tx在数组table强不变式的范围内，因此要验证调用之后table[tx].name满足满足不变性。
    table[tx].level=0;                    // 这是为了维持table数组的数据不变式引入的一个语句。
    table[tx].kind=k;
    switch(k){
    case constant:
        if(num>amax){
        error(31); //num = 0;             // 这个赋值留着没有什么意义。
        }
        table[tx].val=num;
        break;
    case variable:
        table[tx].level=lev; table[tx].addr=dx;
        if(dx < dxmax){
        dx=dx+1;
        }else{
        error(33);                // 声明的变量过多。
        //@ ghost too_many_variables = true;
        exit(1);
        }
        break;
    case proc:
        table[tx].level=lev;
        break;
    }
}


long position(const char* const id1){ // find identifier id in table
    long i;
    int m;                    // 临时增加。
    strcpy(table[0].name, id1);            // 这个函数调用会引起对table[0].name的赋值，但是table[0].name不在talbe不变式的范围内，不必进行强类型不变式的检查。
    i=tx;
    m = strcmp(table[i].name, id1);        // 临时增加。
    /*@ loop invariant
     (\forall integer i:[1..tx].\is_pstring(table[i].name, al) && \string(table[i].name, al) == \old(\string(table[i].name, al))) &&
        \is_pstring(table[0].name, al) && \is_pstring(id1, al) && \string(table[0].name, al) == \string(id1, al) &&
        (\forall integer n:[i+1..tx]. \string(table[n].name, al) != \string(id1, al)) && 0 <= i <= tx &&
        \string(table[i].name, al) == \string(id1, al) && m == 0 ||
     (\forall integer i:[1..tx].\is_pstring(table[i].name, al) && \string(table[i].name, al) == \old(\string(table[i].name, al))) &&
        \is_pstring(table[0].name, al) && \is_pstring(id1, al) && \string(table[0].name, al) == \string(id1, al) &&
        (\forall integer n:[i+1..tx]. \string(table[n].name, al) != \string(id1, al)) && 0 <= i <= tx &&
        \string(table[i].name, al) != \string(id1, al) && m != 0;
    */
    while(m != 0){
    i=i-1;
    m = strcmp(table[i].name, id1);        // 临时增加，同上
    }
    return i;
}